//+------------------------------------------------------------------+
//|                                                         KAMA.mq4 |
//|                                    Copyright? 2009, Walter Choy. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright? 2009, Walter Choy."
#property link      ""

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 DodgerBlue
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 DodgerBlue
#property indicator_color6 Red
//---- input parameters
extern int       kama_period = 10;
extern double    fast_ma_period = 2.0;
extern double    slow_ma_period = 30.0;
//---- buffers
double KAMA[],KAMA_2[];
double KAMA2[],KAMA2_2[];
double KAMA3[],KAMA3_2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0,KAMA);
   SetIndexBuffer(1,KAMA2);
   SetIndexBuffer(2,KAMA3);
   SetIndexBuffer(3,KAMA_2);
   SetIndexBuffer(4,KAMA2_2);
   SetIndexBuffer(5,KAMA3_2);
   SetIndexLabel(0, "KAMA");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {int i,j,limit=Bars-IndicatorCounted()-1;
   
   double er, signal, noise, sc;
   double fastest = 2 / (fast_ma_period + 1);
   double slowest = 2 / (slow_ma_period + 1);
   
   for(i=limit;i>=0;i--){
       er = 1;
       signal = MathAbs(Close[i] - Close[i+kama_period]);
       noise = 0;
      for (j=0; j<kama_period; j++)
         noise += MathAbs(Close[i+j] - Close[i+j+1]);
      if (noise > 0)
         er = signal / noise;
       sc = MathPow((er * (fastest - slowest) + slowest), 2);
      KAMA[i] = KAMA[i+1] + sc * (Close[i] - KAMA[i+1]);
      
      if(KAMA[i+1]<KAMA[i]){KAMA2[i+1]=KAMA[i+1]; KAMA2[i]=KAMA[i];} else{KAMA2[i]=EMPTY_VALUE;}
      
      if(KAMA[i+2]>KAMA[i+1]&&KAMA[i+1]<KAMA[i]){KAMA3[i+2]=KAMA[i+2];KAMA3[i+1]=KAMA[i+1];}
   }
   
   
   for(i=limit;i>=0;i--){
       er = 1;
       signal = MathAbs(KAMA[i] - KAMA[i+kama_period]);
       noise = 0;
      for (j=0; j<kama_period; j++)
         noise += MathAbs(KAMA[i+j] - KAMA[i+j+1]);
      if (noise > 0)
         er = signal / noise;
       sc = MathPow((er * (fastest - slowest) + slowest), 2);
      KAMA_2[i] = KAMA_2[i+1] + sc * (KAMA[i] - KAMA_2[i+1]);
      
      if(KAMA_2[i+1]<KAMA_2[i]){KAMA2_2[i+1]=KAMA_2[i+1]; KAMA2_2[i]=KAMA_2[i];} else{KAMA2_2[i]=EMPTY_VALUE;}
      
      if(KAMA_2[i+2]>KAMA_2[i+1]&&KAMA_2[i+1]<KAMA_2[i]){KAMA3_2[i+2]=KAMA_2[i+2];KAMA3_2[i+1]=KAMA_2[i+1];}
   }
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+